## galax 1.1

=== Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.354 2008/02/21 21:41:21 simeon Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for Galax that relies on the output
#		of a configuration script.  It is an attempt to clean up the
#		existing build process and make it more amenable to packaging
#		systems like GODI.
# History:
#	$Log: Makefile,v $
#	Revision 1.354  2008/02/21 21:41:21  simeon
#	February 21, 2008 - Jerome
#	
#	  o Debian:
#	     - Folded in Stefano's patches.
#	
#	  o Documentation:
#	     - Re-enabled documentation generation.
#	     - Fixed some formatting issues.
#	
#	Revision 1.353  2007/09/27 19:19:28  simeon
#	September 20, 2007 - Jerome
#	
#	** Please run configure again due to changes to detect Camomile's version **
#	
#	  o Galax Compilation:
#	     - Fixes to ./configure to support camomile's version.
#	     - Upgraded to Ocaml 3.10
#	       (changes in compilation due to new camlp4)
#	     - Added support for Camomile 0.7.* on top of Camomile 0.6.
#	       (changes due to new library names)
#	     - Now forcing use of Netsys, coming with latest ocamlnet.
#	
#	  o Join optimization:
#	     - Another fix to the compiler, to properly clean-up selec
#	       clause for join detection.
#	
#	Revision 1.352  2007/08/09 20:21:22  simeon
#	August 9, 2007 - Jerome
#	
#	  o XQueryX:
#	    - Added support for module interfaces in xqueryx2xquery.
#	
#	  o Interfaces:
#	    - Fixed pretty-printing of module interfaces.
#	
#	  o Galax Compilation:
#	    - Added missing dependencies for some target executables to the Galax
#	      library.
#	
#	Revision 1.351  2007/08/01 18:06:30  simeon
#	August 1, 2007 - Jerome
#	
#	  o XQueryX: First-cut support for XQueryX with trivial embedding
#	    in Galax. It supports the following features:
#	
#	     (1) Compiling XQueryX to XQuery using a command line tool called
#	         xqueryx2xquery.
#	
#	     (2) Running XQueryX with galax-run with the flag '-syntax
#	         xqueryx'.
#	
#	     (3) Embedding XQueryX expressions directly within XQuery.
#	
#	  (1) and (2) work on whole modules, while (3) only works with
#	  expressions since it has to be integrated with the rest of the
#	  grammar.
#	
#	  o Processing model:
#	     - Fixed ugly bug in the way parse handlers were built. Now
#	       properly taking configuration into account.
#	
#	Revision 1.350  2007/07/31 17:34:08  simeon
#	July 31, 2007 - Jerome
#	
#	  o Parsing:
#	     - Fixed another lurking bug in the lexing of sequence types,
#	       transitioning to the wrong state... (Was tripped by e.g.,
#	       instance of or typeswitch inside a constructor).
#	
#	       [Replaced old hack by better working new hack...sigh
#	
#	        Queries to test:
#	        <a>{1 instance of item()}</a>
#	        <a>{1 instance of item()*}</a>
#	        <a>{1 instance of item()(::)*}</a>
#	        every $a as item()* in (1, 2), $b as item()* in $a satisfies $b]
#	
#	  o Prolog:
#	     - Fixed another lurking bug in cyclic variable dependency
#	       checking (not clearing up the previous variable table in
#	       parallel branches of the dependency graph).
#	
#	  o XQueryX Trivial Embedding:
#	     - Started prepare for it. Added hook in normalization.
#	
#	Revision 1.349  2007/07/23 18:15:19  ndonose
#	fixed makefile options for zerod
#	
#	Revision 1.348  2007/07/21 17:46:07  ndonose
#	July 21, 2007 - Nicola
#	
#	  o Workflows:
#	    First version of an HTTP server providing an interface for
#	    ProjectZero workflows and acting as proxy towards the DXQ
#	    server running the workflow script.
#	    The current version does not support yet receive activities
#	    that are not enabled from the beginning.
#	
#	Revision 1.347  2007/07/18 16:54:18  simeon
#	July 18, 2007 - Jerome
#	
#	  Feature Galax
#	  Minimal Conformance	          14528 / 96 / 14637  (99.3%)
#	  Optional Features
#	    Schema Import Feature	  0   	/ 0   / 174
#	    Schema Validation Feature	  0   	/ 0   / 25
#	    Static Typing Feature	  46  	/ 0   / 46
#	    Full Axis Feature	 	  130 	/ 0   / 130
#	    Module Feature	 	  0 	/ 0   / 32
#	    Trivial XML Embedding Feature 0 	/ 0   / 4
#	
#	  o WSDL:
#	     - Removing wsdl_load.ml at cleanup-time, since it's being
#	       generated.
#	
#	  o Prolog:
#	     - Added check for cyclic definitions of global variable in
#	       modules.
#	
#	  o Testing:
#	     - Added group testing for the XQuery Appendices.
#	
#	Revision 1.346  2007/07/13 18:24:42  mff
#	July 13, 2007 - Mary
#	
#	   o Xquery_algebra_ast.mli + all files that depends on Algebra AST
#	     - Changes names of AST nodes for imported variables & functions.
#	       Conflated interfaces with imported
#	
#	   o Changed Pervasives _back_ to an XQuery module from an interface,
#	     because it really is a module whose functions are built-in.
#	     Sorry for churn on this.
#	
#	     - Removed stdlib/pervasive.xqi
#	     - Added glx:string_of_item
#	
#	   o Planio
#	     - Fixed bug in parsing of ElementKind and AttributeKind
#	
#	   o Code_execute
#	
#	     - Temporarily disabled optimization of Execute expressions to
#	       local server, which simply evaluate the remote expression
#	       locally, because there is an insidious bug when its called.
#	
#	   o Parse_xquery
#	     - Changed parsing of interfaces so that variables and functions
#	       are correctly tagged as coming from interfaces.  Previously,
#	       did this with an ugly hack in normalization.
#	
#	   o Galaxd & Galax_server
#	     - Added exception-handler argument to tcp_server and udp_server
#	       so that internal errors and async errors can be reported to the
#	       Gui.
#	
#	Revision 1.345  2007/06/28 15:17:30  ndonose
#	June 28, 2007 - Nicola
#	
#	  o WSDL: Updated the WSDL parser to make it work again with the
#	    latest changes in Galax.
#	
#	  o Removed wsdl_load.ml from the repository, as it is supposed to
#	    be generated from wsdl_load.mlp
#	
#	Revision 1.344  2007/05/16 15:32:07  mff
#	
#	
#	May 16, 2007 - Mary
#	
#	  MODULES and INTERFACES
#	  *** PLEASE READ THE WHOLE MESSAGE ***
#	
#	  o Deep changes to support separate module interfaces and module
#	    implementations.
#	
#	    - Compilation/evaluation now occur within context of a "compiled
#	      program".  (In new module code_selection/Compiled_program_units)
#	
#	      A compiled program consists of imported module interfaces,
#	      imported library modules, and an optional main module.
#	
#	    - All program units (statements,prologs,modules) are compiled in
#	      context of a compiled_program unit.
#	
#	    - New pre-processing phase (before normalization), computes
#	      transitive closure of imported library modules.  Used to
#	      populate compiled_program unit.
#	
#	    - Recursive module imports (as per standard) are prohibited.
#	
#	   o Changes to ASTs:
#	
#	     We distinguish between "external" functions/vars (which are
#	     defined in external programming environment) from "imported"
#	     functions/vars (which are defined in imported XQuery modules)
#	
#	     New kinds of declarations:
#	     Xquery_ast : EFunctionInterface and EVarInterface
#	     Xquery_core_ast : CEFunctionInterface and CEVarInterface
#	     Xquery_algebra_ast : AOEFunctionInterface and AOEVarDeclInterface
#	
#	   o Importing interfaces and modules
#	
#	     Module interfaces are imported during normalization.  Variable
#	     and function declarations in the Core rep of the imported
#	     interface are merged into the Core rep of the importing module.
#	
#	     If a module does not have an interface, an interface is created
#	     for it during the pre-processing stage.
#	
#	   o New interface stdlib/pervasive.xqi replaces stdlib/pervasive.xq
#	
#	     - Removed stdlib/pervasive.xq
#	     - NB: new file suffix ".xqi" for module interfaces.
#	
#	   o Code selection
#	
#	     References to imported variables and functions are resolved
#	     during code selection of the importing module.
#	
#	     The code_selection_context for a module points to the
#	     code_selection_contexts of the modules that it imports to resolve
#	     references to imported variables/functions.
#	
#	   o What works:
#	
#	     - Usecase, XQuery testsuite, and Galax regressions all pass
#	
#	   o What doesn't work:
#	
#	     - examples/caml_api/test.ml
#	     - C or Java APIs
#	     - Any DXQ program
#	
#	   o TODO:
#	
#	     - Physical types for external and imported variables: Right now,
#	     they are completely materialized XML values.
#	
#	Revision 1.343  2007/05/02 19:14:08  mff
#	
#	Targets for buildbot regressions
#	
#	Revision 1.342  2007/05/01 21:03:06  mff
#	
#	fast-regression added to Makefile
#	
#	Revision 1.341  2007/05/01 20:32:24  mff
#	
#	Added usecases: target for automated testing
#	
#	Revision 1.340  2007/03/21 15:52:52  mff
#	March 21, 2007 - Mary
#	
#	  o Galax_server:
#	    - Removed log of query-response size that was growing without
#	      bound!
#	    - Drip, drip, drip: other small memory leaks abound...
#	
#	Revision 1.339  2007/02/12 21:15:33  simeon
#	February 12, 2007 - Jerome
#	
#	  o Code clean up:
#	     - Removed obsolete modules: Factorize_update, Factorize_util.
#	
#	  o Galax Test Suite:
#	     - Added a first version of the Galax test suite in the CVS
#	       repository. This currently contains a few tests for: plan
#	       stability of the use cases, and join detection tests.
#	
#	  o Testing:
#	     - Finalized support for comparing query plans in the test
#	       harness.
#	     - Added an option to automatically generate expected results in
#	       case the file for that expected result is missing.
#	
#	       Usage: [galax-test -generate-results] to generate results.
#	
#	  o Toplevel:
#	     - Added three plan conversion utilities for convenience.
#	        [xquery2plan] generates a plan from an XQuery. **
#	        [xquery2xmlplan] generates an XML plan from an XQuery.
#	        [xmlplan2plan] generates a plan from an XML plan.
#	
#	      **you can turn optimization on by writing -optimization on.
#	
#	  o Updates/Parsing:
#	     - Removed 'snap delete' etc. variants for the update
#	       operations. Fixing shift/reduce conflicts. (e.g., WITH could
#	       parse as either a do replace or a snap replace).
#	
#	       The changes are:
#	         MapFromItem[$x]{P1}(P2) --> Map{P1}(P2) where occurrence of $x
#	         in P1 is turned into ID.
#	         MapToItem{P1}(P2) --> Map{P1}(P2)
#	         INPUT --> ID
#	         snap { P } --> Snap(P), same for Delete,Replace,Insert,Rename.
#	
#	  o Pretty printer:
#	     - Fixed the algebraic pretty-printer to align with the current
#	       formalization of the algebra [Ghelli,Onose,Rose,Simeon].
#	
#	  o Compiler:
#	     - Consolidated name creation (variables, tuple fields, etc.)
#	       throughout the compiler. This is now handled by a proper module
#	       [Namespace_generate]. This is important notably for the
#	       regression tests to ensure stability of variable names accross
#	       separate sets of compilation.
#	
#	Revision 1.338  2007/02/01 22:08:45  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
