=== debian/control ===
Source: galax
Section: text
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-nox (>= 3.11.1-3~),
 autotools-dev,
 camlp4,
 libpcre-ocaml-dev,
 libocamlnet-ocaml-dev (>= 4.0.4),
 libpxp-ocaml-dev (>= 1.2.1-1~),
 libcamomile-ocaml-dev,
 hevea,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/galax.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/galax.git
Homepage: http://galax.sourceforge.net/

Package: galax
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Description: XQuery implementation with static typing - command line front-ends
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the command line front-ends to evaluate XQuery queries
 and to validate XML documents against XML Schemas.

Package: galax-extra
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Recommends: galax
Description: XQuery implementation with static typing - utilities
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains several command line utilities which complete the
 front-ends provided by the galax package. Utilities are provided to validate
 XML Schemas and WSDL, inspect query execution plans, and convert queries among
 alternative syntaxes (plain text and XQueryX).

Package: galaxd
Section: net
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Suggests: galax
Description: XQuery implementation with static typing - network servers
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains galaxd, the Galax network server which executes query
 plans issued by remote clients. Extra helpers for remote execution (zerod and
 webgui) are also provided by this package.

Package: libgalax-ocaml-dev
Section: ocaml
Architecture: any
Depends:
 libpcre-ocaml-dev,
 libocamlnet-ocaml-dev,
 libpxp-ocaml-dev,
 libcamomile-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Suggests: ocaml-findlib
Description: XQuery implementation with static typing - OCaml libraries
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the OCaml development libraries to use Galax, as a
 library, in your OCaml applications.

Package: galax-doc
Section: doc
Architecture: all
Suggests:
 galax,
 libgalax-ocaml-dev
Depends: ${misc:Depends}
Description: XQuery implementation with static typing - documentation
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the Galax documentation. User's and reference manuals
 are provided, as well as the OCaml API reference for the Galax library.
