=== debian/watch ===
version=3
http://sf.net/galax/galax-([0-9\.]+)-src\.tar\.gz
